#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "./symcrypt_lib.h"

void print_usage(void) {
  printf("USAGE\n");
  printf("  symcrypt [encrypt|decrypt] SECRET MESSAGE\n");
  printf("  \n");
  printf("  Encrypts or decrypts a MESSAGE using a shared SECRET.\n");
}

int main(int argc, char *argv[]) {
  if (argc != 4) {
    print_usage();
    return 1;
  }

  char *operation = argv[1];
  char *secret = argv[2];
  char *message = argv[3];

  char output[5000];

  if (strcmp(operation, "encrypt") == 0) {
    encrypt(message, secret, output);
    printf("'%s'\n", output);
  } else if (strcmp(operation, "decrypt") == 0) {
    decrypt(message, secret, output);
    printf("'%s'\n", output);
  } else {
    print_usage();
    return 1;
  }

  return 0;
}
