#include <assert.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "./symcrypt_lib.h"

char encrypt_char(char m, char s) {
  int c = (m - ASCII_BEGIN) + (s - ASCII_BEGIN);

  if (c >= ASCII_SIZE) {
    c = c - ASCII_SIZE;
  }

  c = c + ASCII_BEGIN;

  assert(c >= ASCII_BEGIN);
  assert(c < ASCII_END);

  return c;
}

char decrypt_char(char m, char s) {
  int c = (m - ASCII_BEGIN) - (s - ASCII_BEGIN);

  if (c < 0) {
    c = c + ASCII_SIZE;
  }

  c = c + ASCII_BEGIN;

  assert(c >= ASCII_BEGIN);
  assert(c < ASCII_END);

  return c;
}

void encrypt(char *message, char *secret, char *encrypted) {
  size_t message_len = strlen(message);
  size_t secret_len = strlen(secret);
  for (size_t i = 0; i < message_len; ++i) {
    encrypted[i] = encrypt_char(message[i], secret[i % secret_len]);
  }
  encrypted[message_len] = 0;
}

void decrypt(char *message, char *secret, char *decrypted) {
  size_t message_len = strlen(message);
  size_t secret_len = strlen(secret);
  for (size_t i = 0; i < message_len; ++i) {
    decrypted[i] = decrypt_char(message[i], secret[i % secret_len]);
  }
  decrypted[message_len] = 0;
}
