#ifndef SYMCRYPT_LIB_H
#define SYMCRYPT_LIB_H

#include <stdbool.h>
#include <stdlib.h>

/* Range of ASCII chars allowed in message and secret. */
#define ASCII_BEGIN 32
#define ASCII_END 127
#define ASCII_SIZE (ASCII_END - ASCII_BEGIN)

/* Encrypt/Decrypt a single message char `m` with a single secret char `s`. */
char encrypt_char(char m, char s);
char decrypt_char(char m, char s);

/* Encrypt/Decrypt a `message` with a `secret`.
 * The `secret` may be shorter than the message.
 */
void encrypt(char *message, char *secret, char *encrypted);
void decrypt(char *message, char *secret, char *decrypted);

#endif /* SYMCRYPT_LIB_H */
